searchNodes=[{"type":"module","title":"ExSecrets","doc":"This module functions to access secrets in an Elixir application.","ref":"ExSecrets.html"},{"type":"function","title":"ExSecrets.get/2","doc":"Get secret value. You can pass two options: provider: Name of the provider to use. Default is :system_env default_value: Default value to return if secret is not found. Default is nil Examples iex&gt; ExSecrets . get ( &quot;FOO&quot; ) nil iex&gt; Application . put_env ( :ex_secrets , :default_provider , :dot_env ) :ok iex&gt; ExSecrets . get ( &quot;FOO&quot; ) nil iex&gt; System . put_env &quot;FOO&quot; , &quot;BAR&quot; :ok iex&gt; ExSecrets . get ( &quot;FOO&quot; ) &quot;BAR&quot; iex&gt; System . delete_env &quot;FOO&quot; :ok iex&gt; ExSecrets . get ( &quot;FOO&quot; ) &quot;BAR&quot; iex&gt; ExSecrets . reset ( ) :ok iex&gt; ExSecrets . get ( &quot;FOO&quot; ) nil iex&gt; Application . delete_env ( :ex_secrets , :default_provider ) :ok iex&gt; Application . put_env ( :ex_secrets , :providers , %{ dot_env : %{ path : &quot;test/support/fixtures/dot_env_test.env&quot; } } ) :ok iex&gt; ExSecrets . get ( &quot;ERL&quot; , provider : :dot_env ) nil iex&gt; ExSecrets . get ( &quot;ERL&quot; , provider : :dot_env , default_value : &quot;ANG&quot; ) &quot;ANG&quot; iex&gt; Application . delete_env ( :ex_secrets , :providers ) :ok iex&gt; Application . put_env ( :ex_secrets , :providers , %{ dot_env : %{ path : &quot;test/support/fixtures/dot_env_test.env&quot; } } ) :ok iex&gt; ExSecrets . get ( &quot;DEVS&quot; , provider : :dot_env ) &quot;ROCKS&quot; iex&gt; Application . delete_env ( :ex_secrets , :providers ) :ok","ref":"ExSecrets.html#get/2"},{"type":"function","title":"ExSecrets.get/3","doc":"Get secret value with provider name and default value","ref":"ExSecrets.html#get/3"},{"type":"function","title":"ExSecrets.get_using_provider/2","doc":"Internal function for fetching secret with provide for catching and rate limiting. Do not rely on this function.","ref":"ExSecrets.html#get_using_provider/2"},{"type":"function","title":"ExSecrets.reset/0","doc":"Resets cache and reloads all providers.","ref":"ExSecrets.html#reset/0"},{"type":"function","title":"ExSecrets.set/3","doc":"Set secret value. Supported for providers: :system_env :dot_env :azure_key_vault :azure_managed_identity :google_secret_manager Calling this function requires the provider to be configured with credentials that allow create secrets like Secret Admionistrator in Azure Key Vault. Examples iex&gt; File . touch ( &quot;.env.dev&quot; ) :ok iex&gt; Application . put_env ( :ex_secrets , :providers , %{ dot_env : %{ path : &quot;.env.dev&quot; } } ) :ok iex&gt; ExSecrets . set ( &quot;TEST&quot; , &quot;test&quot; , provider : :dot_env ) :ok iex&gt; Application . delete_env ( :ex_secrets , :providers ) :ok iex&gt; File . rm ( &quot;.env.dev&quot; )","ref":"ExSecrets.html#set/3"},{"type":"module","title":"ExSecrets.Application","doc":"Application for adding providers and cache to the supervision tree. All are besically GenServers that do a bunch of API calls and file access like .env reader","ref":"ExSecrets.Application.html"},{"type":"function","title":"ExSecrets.Application.get_providers/0","doc":"","ref":"ExSecrets.Application.html#get_providers/0"},{"type":"function","title":"ExSecrets.Application.get_providers/1","doc":"","ref":"ExSecrets.Application.html#get_providers/1"},{"type":"function","title":"ExSecrets.Application.start/2","doc":"Callback implementation for Application.start/2 .","ref":"ExSecrets.Application.html#start/2"},{"type":"module","title":"ExSecrets.Cache","doc":"Cache module provides helper functions for caching secrets.","ref":"ExSecrets.Cache.html"},{"type":"function","title":"ExSecrets.Cache.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExSecrets.Cache.html#child_spec/1"},{"type":"function","title":"ExSecrets.Cache.get/1","doc":"","ref":"ExSecrets.Cache.html#get/1"},{"type":"function","title":"ExSecrets.Cache.pass_by/2","doc":"","ref":"ExSecrets.Cache.html#pass_by/2"},{"type":"function","title":"ExSecrets.Cache.save/2","doc":"","ref":"ExSecrets.Cache.html#save/2"},{"type":"function","title":"ExSecrets.Cache.start_link/1","doc":"","ref":"ExSecrets.Cache.html#start_link/1"},{"type":"behaviour","title":"ExSecrets.HTTPAdapterBehavior","doc":"Behaviour for HTTP adapters.","ref":"ExSecrets.HTTPAdapterBehavior.html"},{"type":"callback","title":"ExSecrets.HTTPAdapterBehavior.get/2","doc":"","ref":"ExSecrets.HTTPAdapterBehavior.html#c:get/2"},{"type":"callback","title":"ExSecrets.HTTPAdapterBehavior.post/3","doc":"","ref":"ExSecrets.HTTPAdapterBehavior.html#c:post/3"},{"type":"module","title":"ExSecrets.Providers.AwsSecretsManager","doc":"This module provides a provider for AWS Secrets Manager - https://aws.amazon.com/secrets-manager/ Code for authenticating with AWS has been has been forked from ex_aws See https://github.com/ex-aws/ex_aws Configuration config :ex_secrets , :providers , %{ aws_secrets_manager : %{ access_key_id : &quot;taccess_key_id&quot; , secret_access_key : &quot;secret_access_key&quot; } } Its is recomended to create an access key and secret access key for the access key with only the required permissions. Limiting thye scope of the access key will help in reducing the risk of the access key being compromised.","ref":"ExSecrets.Providers.AwsSecretsManager.html"},{"type":"function","title":"ExSecrets.Providers.AwsSecretsManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExSecrets.Providers.AwsSecretsManager.html#child_spec/1"},{"type":"function","title":"ExSecrets.Providers.AwsSecretsManager.get/1","doc":"Callback implementation for ExSecrets.Providers.Behaviour.get/1 .","ref":"ExSecrets.Providers.AwsSecretsManager.html#get/1"},{"type":"function","title":"ExSecrets.Providers.AwsSecretsManager.get_secret/3","doc":"","ref":"ExSecrets.Providers.AwsSecretsManager.html#get_secret/3"},{"type":"function","title":"ExSecrets.Providers.AwsSecretsManager.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"ExSecrets.Providers.AwsSecretsManager.html#init/1"},{"type":"function","title":"ExSecrets.Providers.AwsSecretsManager.process_name/0","doc":"","ref":"ExSecrets.Providers.AwsSecretsManager.html#process_name/0"},{"type":"function","title":"ExSecrets.Providers.AwsSecretsManager.reset/0","doc":"Callback implementation for ExSecrets.Providers.Behaviour.reset/0 .","ref":"ExSecrets.Providers.AwsSecretsManager.html#reset/0"},{"type":"function","title":"ExSecrets.Providers.AwsSecretsManager.set/2","doc":"Callback implementation for ExSecrets.Providers.Behaviour.set/2 .","ref":"ExSecrets.Providers.AwsSecretsManager.html#set/2"},{"type":"function","title":"ExSecrets.Providers.AwsSecretsManager.start_link/1","doc":"","ref":"ExSecrets.Providers.AwsSecretsManager.html#start_link/1"},{"type":"module","title":"ExSecrets.Providers.AzureKeyVault","doc":"Azure Key Vault provider provides secrets from an Azure Key Vault through a rest API. Configuration You can configure this provider as shown below. Either client_secret or client_cert_path is required to implement authentication. Client client_certificate_? is recommended for security. If you provide both, client_certificate_? is used. All other config options are mandatory. config :ex_secrets , :providers , % { azure_key_vault : %{ tenant_id : &quot;tenant-id&quot; , client_id : &quot;client-id&quot; , client_secret : &quot;client-secret&quot; , client_certificate_string : &quot;base 64 encoded contents of cert.key&quot; , client_certificate_path : &quot;/path/cert.key&quot; , client_certificate_x5t : &quot;x5t&quot; , key_vault_name : &quot;key-vault-name&quot; } See notes below on setting up authentication. Authentication The service pricipal being used must have a role that can access the secrets eg Key Vault Secrets User . Secret Authentication This is prety straing forward. See the stps below from Being Chat Here is a step-by-step guide to generate a secret for an app on Azure AD App Registration Secrets page: Sign in to the Azure portal. Navigate to the Azure Active Directory &gt; App registrations &gt; Owned applications. Select your application. Click on Certificates &amp; secrets &gt; Client secrets &gt; New client secret. Type a description and an expiration for the client’s secret. Click Add. For more information on generating client secrets in Azure AD, please refer to 12 Certificate Authentication MacOS and many Linux distributions come with pre-compiled OpenSSL packages. You can run the following command directly from a shell to confirm if OpenSSL has already been installed. Create a Certificate Signing Request (.csr file) and generate a private key (.key file) using the following command: openssl req - newkey rsa : 4096 - nodes - keyout mycert . key - batch - out mycert . csr This command will generate a simple CSR and download a 4096-bit private key in your current directory for self-signature. Next, self-sign the certificate using the private key that was just generated: openssl x509 - key mycert . key - in mycert . csr - req - days 3650 - out mycert . crt You may replace validity period 3650 with any number of days you wish. Just be aware that once the period of validity has expired, you will need to replace the certificate with a new one. Upload the .crt file to Azure portal using the Being Chat steps below. Here is a step-by-step guide to upload a certificate for an app on Azure AD App Registration Secrets page: Sign in to the Azure portal. Navigate to the Azure Active Directory &gt; App registrations &gt; Owned applications. Select your application. Click on Certificates &amp; secrets &gt; Certificates &gt; Upload certificate. Browse to the .crt certificate file saved on your local machine and select it. Type a description for the certificate. Click Add. Finally generate the x5t JWT header required by Entra using the command below. See https://learn.microsoft.com/en-us/entra/identity-platform/certificate-credentials#assertion-format . openssl x509 - in mycert . crt - fingerprint - noout | sed &#39;s/SHA1 Fingerprint=//g&#39; | sed &#39;s/://g&#39; | xxd - r - ps | base64 Save the value as client_certificate_x5t in the config.","ref":"ExSecrets.Providers.AzureKeyVault.html"},{"type":"function","title":"ExSecrets.Providers.AzureKeyVault.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExSecrets.Providers.AzureKeyVault.html#child_spec/1"},{"type":"function","title":"ExSecrets.Providers.AzureKeyVault.get/1","doc":"Callback implementation for ExSecrets.Providers.Behaviour.get/1 .","ref":"ExSecrets.Providers.AzureKeyVault.html#get/1"},{"type":"function","title":"ExSecrets.Providers.AzureKeyVault.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"ExSecrets.Providers.AzureKeyVault.html#init/1"},{"type":"function","title":"ExSecrets.Providers.AzureKeyVault.process_name/0","doc":"","ref":"ExSecrets.Providers.AzureKeyVault.html#process_name/0"},{"type":"function","title":"ExSecrets.Providers.AzureKeyVault.reset/0","doc":"Callback implementation for ExSecrets.Providers.Behaviour.reset/0 .","ref":"ExSecrets.Providers.AzureKeyVault.html#reset/0"},{"type":"function","title":"ExSecrets.Providers.AzureKeyVault.set/2","doc":"Callback implementation for ExSecrets.Providers.Behaviour.set/2 .","ref":"ExSecrets.Providers.AzureKeyVault.html#set/2"},{"type":"function","title":"ExSecrets.Providers.AzureKeyVault.start_link/1","doc":"","ref":"ExSecrets.Providers.AzureKeyVault.html#start_link/1"},{"type":"module","title":"ExSecrets.Providers.AzureManagedIdentity","doc":"Azure Key Vault provider provides secrets from an Azure Key Vault through a rest API. Only the keyvault name is required here once the managed identity has been given access to the keyvault. config :ex_secrets , :providers , % { azure_managed_identity : %{ key_vault_name : &quot;key-vault-name&quot; } The provider will handle token renewals and secret fetch.","ref":"ExSecrets.Providers.AzureManagedIdentity.html"},{"type":"function","title":"ExSecrets.Providers.AzureManagedIdentity.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExSecrets.Providers.AzureManagedIdentity.html#child_spec/1"},{"type":"function","title":"ExSecrets.Providers.AzureManagedIdentity.get/1","doc":"Callback implementation for ExSecrets.Providers.Behaviour.get/1 .","ref":"ExSecrets.Providers.AzureManagedIdentity.html#get/1"},{"type":"function","title":"ExSecrets.Providers.AzureManagedIdentity.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"ExSecrets.Providers.AzureManagedIdentity.html#init/1"},{"type":"function","title":"ExSecrets.Providers.AzureManagedIdentity.process_name/0","doc":"","ref":"ExSecrets.Providers.AzureManagedIdentity.html#process_name/0"},{"type":"function","title":"ExSecrets.Providers.AzureManagedIdentity.reset/0","doc":"Callback implementation for ExSecrets.Providers.Behaviour.reset/0 .","ref":"ExSecrets.Providers.AzureManagedIdentity.html#reset/0"},{"type":"function","title":"ExSecrets.Providers.AzureManagedIdentity.set/2","doc":"Callback implementation for ExSecrets.Providers.Behaviour.set/2 .","ref":"ExSecrets.Providers.AzureManagedIdentity.html#set/2"},{"type":"function","title":"ExSecrets.Providers.AzureManagedIdentity.set_secret/4","doc":"","ref":"ExSecrets.Providers.AzureManagedIdentity.html#set_secret/4"},{"type":"function","title":"ExSecrets.Providers.AzureManagedIdentity.start_link/1","doc":"","ref":"ExSecrets.Providers.AzureManagedIdentity.html#start_link/1"},{"type":"module","title":"ExSecrets.Providers.Base","doc":"Base provider provides the basic functions to be implemented by a provider. This macro is used to implement the basic functions of a provider.","ref":"ExSecrets.Providers.Base.html"},{"type":"behaviour","title":"ExSecrets.Providers.Behaviour","doc":"Behaviour for providers.","ref":"ExSecrets.Providers.Behaviour.html"},{"type":"callback","title":"ExSecrets.Providers.Behaviour.get/1","doc":"Gets a secret from the provider.","ref":"ExSecrets.Providers.Behaviour.html#c:get/1"},{"type":"callback","title":"ExSecrets.Providers.Behaviour.reset/0","doc":"Resets the provider to default state. Clears cache and resets the provider.","ref":"ExSecrets.Providers.Behaviour.html#c:reset/0"},{"type":"callback","title":"ExSecrets.Providers.Behaviour.set/2","doc":"","ref":"ExSecrets.Providers.Behaviour.html#c:set/2"},{"type":"module","title":"ExSecrets.Providers.DotEnv","doc":"DotEnv provider provides secrets from a .env file.","ref":"ExSecrets.Providers.DotEnv.html"},{"type":"function","title":"ExSecrets.Providers.DotEnv.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExSecrets.Providers.DotEnv.html#child_spec/1"},{"type":"function","title":"ExSecrets.Providers.DotEnv.get/1","doc":"Callback implementation for ExSecrets.Providers.Behaviour.get/1 .","ref":"ExSecrets.Providers.DotEnv.html#get/1"},{"type":"function","title":"ExSecrets.Providers.DotEnv.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"ExSecrets.Providers.DotEnv.html#init/1"},{"type":"function","title":"ExSecrets.Providers.DotEnv.process_name/0","doc":"","ref":"ExSecrets.Providers.DotEnv.html#process_name/0"},{"type":"function","title":"ExSecrets.Providers.DotEnv.reset/0","doc":"Callback implementation for ExSecrets.Providers.Behaviour.reset/0 .","ref":"ExSecrets.Providers.DotEnv.html#reset/0"},{"type":"function","title":"ExSecrets.Providers.DotEnv.set/2","doc":"Callback implementation for ExSecrets.Providers.Behaviour.set/2 .","ref":"ExSecrets.Providers.DotEnv.html#set/2"},{"type":"function","title":"ExSecrets.Providers.DotEnv.start_link/1","doc":"","ref":"ExSecrets.Providers.DotEnv.html#start_link/1"},{"type":"module","title":"ExSecrets.Providers.GoogleSecretManager","doc":"Google Secret Manager provider provides secrets from an Google Secret Manager through a rest API. Configuration Using the Service Account Credentials File Application . put_env ( :ex_secrets , :providers , %{ google_secret_manager : %{ service_account_credentials_path : &quot;.temp/cred.json&quot; } } ) Using the json file contents Application . put_env ( :ex_secrets , :providers , %{ google_secret_manager : %{ service_account_credentials : %{ &quot;type&quot; =&gt; &quot;service_account&quot; , &quot;project_id&quot; =&gt; &quot;project-id&quot; , &quot;private_key_id&quot; =&gt; &quot;keyid&quot; , &quot;private_key&quot; =&gt; &quot;-----BEGIN PRIVATE KEY-----...-----END PRIVATE KEY----- &quot; , &quot;client_email&quot; =&gt; &quot;secretaccess@project-id.iam.gserviceaccount.com&quot; , &quot;client_id&quot; =&gt; &quot;client-id&quot; , &quot;auth_uri&quot; =&gt; &quot;https://accounts.google.com/o/oauth2/auth&quot; , &quot;token_uri&quot; =&gt; &quot;https://oauth2.googleapis.com/token&quot; , &quot;auth_provider_x509_cert_url&quot; =&gt; &quot;https://www.googleapis.com/oauth2/v1/certs&quot; , &quot;client_x509_cert_url&quot; =&gt; &quot;https://www.googleapis.com/robot/v1/metadata/x509/secretaccess%40project-id.iam.gserviceaccount.com&quot; , &quot;universe_domain&quot; =&gt; &quot;googleapis.com&quot; } } } ) CRC32C Verification When google returns the CRC32C value, the provider will verify the value with the data returned from the API. If the values do not match, the provider will return an error. The provider uses the crc32cer library https://hex.pm/packages/crc32cer to verify the CRC32C value.","ref":"ExSecrets.Providers.GoogleSecretManager.html"},{"type":"function","title":"ExSecrets.Providers.GoogleSecretManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExSecrets.Providers.GoogleSecretManager.html#child_spec/1"},{"type":"function","title":"ExSecrets.Providers.GoogleSecretManager.get/1","doc":"Callback implementation for ExSecrets.Providers.Behaviour.get/1 .","ref":"ExSecrets.Providers.GoogleSecretManager.html#get/1"},{"type":"function","title":"ExSecrets.Providers.GoogleSecretManager.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"ExSecrets.Providers.GoogleSecretManager.html#init/1"},{"type":"function","title":"ExSecrets.Providers.GoogleSecretManager.process_name/0","doc":"","ref":"ExSecrets.Providers.GoogleSecretManager.html#process_name/0"},{"type":"function","title":"ExSecrets.Providers.GoogleSecretManager.reset/0","doc":"Callback implementation for ExSecrets.Providers.Behaviour.reset/0 .","ref":"ExSecrets.Providers.GoogleSecretManager.html#reset/0"},{"type":"function","title":"ExSecrets.Providers.GoogleSecretManager.set/2","doc":"Callback implementation for ExSecrets.Providers.Behaviour.set/2 .","ref":"ExSecrets.Providers.GoogleSecretManager.html#set/2"},{"type":"function","title":"ExSecrets.Providers.GoogleSecretManager.start_link/1","doc":"","ref":"ExSecrets.Providers.GoogleSecretManager.html#start_link/1"},{"type":"module","title":"ExSecrets.Providers.SystemEnv","doc":"SystemEnv provider provides secrets from the system environment.","ref":"ExSecrets.Providers.SystemEnv.html"},{"type":"function","title":"ExSecrets.Providers.SystemEnv.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExSecrets.Providers.SystemEnv.html#child_spec/1"},{"type":"function","title":"ExSecrets.Providers.SystemEnv.get/1","doc":"Callback implementation for ExSecrets.Providers.Behaviour.get/1 .","ref":"ExSecrets.Providers.SystemEnv.html#get/1"},{"type":"function","title":"ExSecrets.Providers.SystemEnv.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"ExSecrets.Providers.SystemEnv.html#init/1"},{"type":"function","title":"ExSecrets.Providers.SystemEnv.process_name/0","doc":"","ref":"ExSecrets.Providers.SystemEnv.html#process_name/0"},{"type":"function","title":"ExSecrets.Providers.SystemEnv.reset/0","doc":"Callback implementation for ExSecrets.Providers.Behaviour.reset/0 .","ref":"ExSecrets.Providers.SystemEnv.html#reset/0"},{"type":"function","title":"ExSecrets.Providers.SystemEnv.set/2","doc":"Callback implementation for ExSecrets.Providers.Behaviour.set/2 .","ref":"ExSecrets.Providers.SystemEnv.html#set/2"},{"type":"function","title":"ExSecrets.Providers.SystemEnv.start_link/1","doc":"","ref":"ExSecrets.Providers.SystemEnv.html#start_link/1"},{"type":"module","title":"ExSecrets.Utils.Config","doc":"Config module provides helper functions for getting configuration values.","ref":"ExSecrets.Utils.Config.html"},{"type":"function","title":"ExSecrets.Utils.Config.provider_config_value/2","doc":"","ref":"ExSecrets.Utils.Config.html#provider_config_value/2"},{"type":"function","title":"ExSecrets.Utils.Config.provider_config_value/3","doc":"","ref":"ExSecrets.Utils.Config.html#provider_config_value/3"},{"type":"function","title":"ExSecrets.Utils.Config.provider_env/1","doc":"","ref":"ExSecrets.Utils.Config.html#provider_env/1"},{"type":"module","title":"ExSecrets.Utils.Resolver","doc":"Resolver module resolves the provider name to the actual provider module.","ref":"ExSecrets.Utils.Resolver.html"},{"type":"function","title":"ExSecrets.Utils.Resolver.call/1","doc":"","ref":"ExSecrets.Utils.Resolver.html#call/1"},{"type":"module","title":"ExSecrets.Utils.SecretFetchLimiter","doc":"Secret fetch limiter module limits the number of secret fetches in a given time.","ref":"ExSecrets.Utils.SecretFetchLimiter.html"},{"type":"function","title":"ExSecrets.Utils.SecretFetchLimiter.allow/4","doc":"","ref":"ExSecrets.Utils.SecretFetchLimiter.html#allow/4"},{"type":"function","title":"ExSecrets.Utils.SecretFetchLimiter.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExSecrets.Utils.SecretFetchLimiter.html#child_spec/1"},{"type":"function","title":"ExSecrets.Utils.SecretFetchLimiter.start_link/1","doc":"","ref":"ExSecrets.Utils.SecretFetchLimiter.html#start_link/1"},{"type":"function","title":"ExSecrets.Utils.SecretFetchLimiter.track/1","doc":"","ref":"ExSecrets.Utils.SecretFetchLimiter.html#track/1"},{"type":"exception","title":"ExSecrets.Exceptions.InvalidConfiguration","doc":"","ref":"ExSecrets.Exceptions.InvalidConfiguration.html"},{"type":"exception","title":"ExSecrets.Exceptions.UnknowProvider","doc":"","ref":"ExSecrets.Exceptions.UnknowProvider.html"},{"type":"extras","title":"ExSecrets","doc":"App config secret manager for different providers.","ref":"readme.html"},{"type":"extras","title":"ExSecrets - Installation","doc":"Install by adding ex_secrets to your list of dependencies in mix.exs : def deps do [ { :ex_secrets , &quot;~&gt; 0.3.0&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"ExSecrets - How it works","doc":"This library loads secrets on demand from APIs or files. For dotenv file, it is loaded at startup and saved in the cache. Secrets are encrypted when store in the cache with a master key generated at startup. Enables developers to access keys securely. Key features include: FETCH and SET secrets. Key fetch throttling. Authentications with providers like Azure Keyvault and Google Secrets manager and token renewals. Catching of secrets. Default key options. You can configure multiple secrets and access from different providers. RESET and RELOAD secrets without shutting down your application.","ref":"readme.html#how-it-works"},{"type":"extras","title":"ExSecrets - Usage","doc":"Get a secret Secrets are first fetched using system environment. If found thats the value that is used. For this, no configuration is required. iex(1)&gt; ExSecrets . get ( &quot;FOO&quot; ) nil iex(2)&gt; System . put_env &quot;FOO&quot; , &quot;BAR&quot; :ok iex(3)&gt; ExSecrets . get ( &quot;FOO&quot; ) &quot;BAR&quot; iex(4)&gt; To overide secret fetch from system environment by default, Specify your own default provider. iex(1)&gt; ExSecrets . get ( &quot;FOO&quot; ) nil iex(2)&gt; Application . put_env ( :ex_secrets , :default_provider , :dot_env ) :ok iex(3)&gt; ExSecrets . get ( &quot;FOO&quot; ) nil iex(4)&gt; System . put_env &quot;FOO&quot; , &quot;BAR&quot; :ok iex(5)&gt; ExSecrets . get ( &quot;FOO&quot; ) nil iex(7)&gt; Set Secret You can set a new secret version using: iex(20)&gt; ExSecrets . set ( &quot;TEST&quot; , &quot;test&quot; , provider : :azure_key_vault ) :ok Reset and Reload To reset the secrets and reload, this will clear the cached values and reload doenv. For other providers, values will be fetched on demand. iex(20)&gt; ExSecrets . reset ( ) :ok","ref":"readme.html#usage"},{"type":"extras","title":"ExSecrets - Supported Providers","doc":"You can configure: Dot env file Azure Keyvault Azure Managed Identity Google Secret Manager AWS Secret Manager","ref":"readme.html#supported-providers"},{"type":"extras","title":"ExSecrets - Provider Config","doc":"Azure KeyVault configuration: config :ex_secrets , :providers , %{ azure_key_vault : %{ tenant_id : &quot;tenant-id&quot; , client_id : &quot;client-id&quot; , client_secret : &quot;client-secret&quot; , key_vault_name : &quot;key-vault-name&quot; } } Using certificate. You can use client_certificate_path or client_certificate_string . See Azure keyvault provider section for more details config :ex_secrets , :providers , %{ azure_key_vault : %{ tenant_id : &quot;tenant-id&quot; , client_id : &quot;client-id&quot; , client_certificate_path : &quot;/path-to/mycert.key&quot; , client_certificate_string : &quot;base 64 encoded string of the cert&quot; , client_certificate_x5t : &quot;x5t of the cert&quot; , key_vault_name : &quot;key-vault-name&quot; } } Azure Managed Identity Configuration: config :ex_secrets , :providers , %{ azure_managed_identity : %{ key_vault_name : &quot;key-vault-name&quot; } } Google Secret Manager Using service account. You can use service_account_credentials or service_account_credentials_path . See Azure keyvault provider section for more details config :ex_secrets , :providers , %{ google_secret_manager : %{ service_account_credentials : %{ &quot;type&quot; =&gt; &quot;service_account&quot; , &quot;project_id&quot; =&gt; &quot;project-id&quot; , &quot;private_key_id&quot; =&gt; &quot;key-id&quot; , &quot;private_key&quot; =&gt; &quot;-----BEGIN PRIVATE KEY-----...-----END PRIVATE KEY----- \\n &quot; , &quot;client_email&quot; =&gt; &quot;secretaccess@project-id.iam.gserviceaccount.com&quot; , &quot;client_id&quot; =&gt; &quot;client-id&quot; , &quot;auth_uri&quot; =&gt; &quot;https://accounts.google.com/o/oauth2/auth&quot; , &quot;token_uri&quot; =&gt; &quot;https://oauth2.googleapis.com/token&quot; , &quot;auth_provider_x509_cert_url&quot; =&gt; &quot;https://www.googleapis.com/oauth2/v1/certs&quot; , &quot;client_x509_cert_url&quot; =&gt; &quot;https://www.googleapis.com/robot/v1/metadata/x509/secretaccess%40project-id.iam.gserviceaccount.com&quot; , &quot;universe_domain&quot; =&gt; &quot;googleapis.com&quot; } , service_account_credentials_path : &quot;/path-to/cred.json&quot; } } AWS Secret Manager: Using secret access key. Using instance role is coming soon. config :ex_secrets , :providers , %{ aws_secrets_manager : %{ access_key_id : &quot;taccess_key_id&quot; , secret_access_key : &quot;secret_access_key&quot; } } Dotenv file: config :ex_secrets , :providers , %{ dot_env : %{ path : &quot;/path/.env&quot; } }","ref":"readme.html#provider-config"},{"type":"extras","title":"GUIDES","doc":"","ref":"guides.html"},{"type":"extras","title":"CHANGELOG","doc":"","ref":"changelog.html"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]